#include <allegro.h>		
#include <stdlib.h>
#include <stdio.h>

#include "music.h"


MIDI *the_music;

int oldMusic = 0;
int MusicChoice = 1;

void Music_shutdown()
{
 remove_sound();	
 destroy_midi(the_music);
}

void MusicInit()
{
 if (install_sound(DIGI_AUTODETECT, MIDI_AUTODETECT, "scream.wav") != 0) {
    allegro_message("Error initialising sound system\n%s\n", allegro_error);
 }   
 set_volume( 150, 200 );   	
 the_music = load_midi("title.mid");
 if (!the_music) {			
    allegro_message("Error reading MIDI file '%s'\n", "title.mid");
 }
 play_midi(the_music, TRUE);		
}

void MusicKeys()
{
 if( key[KEY_1] ) MusicChoice = 1;
 else if( key[KEY_2] ) MusicChoice = 2;
 else if( key[KEY_3] ) MusicChoice = 3;
 else if( key[KEY_4] ) MusicChoice = 4;
 else if( key[KEY_5] ) MusicChoice = 5;
 else if( key[KEY_6] ) MusicChoice = 6;
 else if( key[KEY_7] ) MusicChoice = 7;
 else if( key[KEY_8] ) MusicChoice = 8;
 else if( key[KEY_9] ) MusicChoice = 9;
}

void SelectMusic()
{	
 set_volume( 150, 200 );   	
 if( oldMusic != MusicChoice )
 {
  destroy_midi(the_music);	
  oldMusic = MusicChoice;
  switch(MusicChoice)
  {
  	case 1: the_music = load_midi("1.mid");
  	   break;
  	case 2: the_music = load_midi("2.mid");
  	   break;
  	case 3: the_music = load_midi("3.mid");
  	   break;
	case 4: the_music = load_midi("4.mid");
  	   break;
	case 5: the_music = load_midi("5.mid");
  	   break;
	case 6: the_music = load_midi("6.mid");
  	   break;
	case 7: the_music = load_midi("7.mid");
  	   break;
	case 8: the_music = load_midi("8.mid");
  	   break;  	
  	default: the_music = load_midi("title.mid");
  }
   if (!the_music) {			
      allegro_message("Error reading MIDI file '%s'\n", "mid");
   }
   play_midi(the_music, TRUE);	
 }
}
