#include <allegro.h>		
#include <stdlib.h>
#include <stdio.h>

#include "music.h"
#include "sound.h"
#include "title.h"
#include "player.h"
#include "stopkey.h"

int quit = 0;
int stop = 0;
int TheRest = 1;
int ArenaWidth = 540;
int ArenaHeight = 380;
int Arena[540][380];

Player player1, player2;

Player CheckPosition(Player player)
{
 int PosX, PosY;
 PosX = player.PosX - 50;
 PosY = player.PosY - 50;

 if( player.NextMove == 'D' )
 	PosY++;

 if( player.NextMove == 'U' )
 	PosY--;

 if( player.NextMove == 'L' )
	PosX--;

 if( player.NextMove == 'R' )
	PosX++;

 if( PosX < 0 || PosX > ArenaWidth || PosY < 0 || PosY > ArenaHeight || Arena[PosX][PosY] == 1)
 {
  stop = 1;
  player.Score += 1;
 }

 return player;
}

void CheckNormals()
{
 if (key[KEY_Q])
 {
  quit = 1;
  stop = 1;
 }
 else if (key[KEY_EQUALS])
 {
  TheRest--;
  if( TheRest < 1 )
    	TheRest = 1;
  else rest(100);
 }
 else if (key[KEY_MINUS])
 {
  TheRest++;
  if( TheRest > 30 )
  	TheRest = 30;
  else rest(100);
 }
}

Player CheckKeys(Player player)
{
 MusicKeys();

 if (player.theKeys.MoveLeft)
 {
  player.LastMove = player.NextMove;
  
  if(player.LastMove == 'R')
   player.NextMove = 'U';
  else if(player.LastMove == 'U')
   player.NextMove = 'L';
  else if(player.LastMove == 'D')
   player.NextMove = 'R';
  else if(player.LastMove == 'L')
   player.NextMove = 'D';
 }

 if (player.theKeys.MoveRight)
 {
  player.LastMove = player.NextMove;
  
  if(player.LastMove == 'R')
   player.NextMove = 'D';
  else if(player.LastMove == 'U')
   player.NextMove = 'R';
  else if(player.LastMove == 'D')
   player.NextMove = 'L';
  else if(player.LastMove == 'L')
   player.NextMove = 'U';
 }
 CheckNormals();
 return player;
}

Player DrawPosition(Player player)
{
 int oldX = player.PosX;
 int oldY = player.PosY;

 if( player.NextMove == 'D' )
 	player.PosY += 1;

 if( player.NextMove == 'U' )
 	player.PosY -= 1;

 if( player.NextMove == 'L' )
 	player.PosX -= 1;

 if( player.NextMove == 'R' )
 	player.PosX += 1;

 int k = 0;
 while( k < 3 )
 { 
  if( player.Colour[k] < 255 )
     player.Colour[k] += 10;
  else if( player.Colour[k] > 255 )
     player.Colour[k] = 100;
  k++;
 }
 rectfill(screen, player.PosX, player.PosY, oldX, oldY, makecol(player.Colour[0], player.Colour[1], player.Colour[2])); 
 Arena[player.PosX - 50][player.PosY - 50] = 1;
 return player;
}


static void RunTime()
{
 player1 = reinitialize_player1(player1);
 player2 = reinitialize_player2(player2);
 clear_to_color (screen, makecol(0,0,0));
 rectfill(screen, 0, 20, 640, 480, makecol(50,50,50)); 
 rectfill(screen, 51, 51, 589, 429, makecol(0,0,0)); 
 int i, j;
 for(i = 0; i < ArenaHeight; i++) 
   for(j = 0; j < ArenaWidth; j++)
	Arena[j][i] = 0;
 
 clearScore();
 drawScore(player1, player2);
 player1 = DrawPosition(player1);
 player2 = DrawPosition(player2);
 rest(1000);
 
 while( stop == 0 )
 {
  rest(TheRest);
  SelectMusic();
  player1.theKeys = MoveAround(player1.theKeys);
  player2.theKeys = MoveAround(player2.theKeys);
  player1 = CheckKeys(player1);
  player2 = CheckKeys(player2);
  player1 = CheckPosition(player1);
  player2 = CheckPosition(player2);
  vsync();
  player1 = DrawPosition(player1);
  player2 = DrawPosition(player2);
 }
 if( quit == 0 )
 {	
     PlayDeath();
 }
  clear_keybuf();
}

int main (int argc, char *argv[])
{  
   init();
   MusicInit();
   Sound_Init();
   TitleScreen();
   game_init();
   title_shutdown();
   
   player1 = initialize_player1(player1);
   player2 = initialize_player2(player2);
   
   while( quit == 0 )
   {	
    RunTime();
    if( quit == 0 )
	readkey();
    stop = 0;	
   }
   Music_shutdown();
   Sound_shutdown();
   shutdown();
   return 0;			
}
END_OF_MAIN()
