#include <allegro.h>		
#include <stdlib.h>
#include <stdio.h>

#include "error.h"
#include "title.h"
#include "player.h"

static BITMAP *titlescreen;
static PALETTE palette;

static BITMAP *score, *arena;

void clearScore()
{
 rectfill(score, 0, 0, 640, 20, makecol(0,0,0)); 	
}

void DrawScores(Player player)
{
 char string[100];
	
 sprintf (string, "Score: %d", player.Score);
 text_mode (-1); 
 textout (score, font, player.name, player.ScorePos, 5, makecol(255,255,255));
 textout (score, font, string, player.ScorePos+80, 5, makecol(255,255,255));
}

void drawScore(Player player1, Player player2) 
{
 int temp;
 temp = player1.Score;
 player1.Score = player2.Score;
 player2.Score = temp;	 
 
 DrawScores(player1);
 DrawScores(player2);
}

void game_init() 
{
	if (set_gfx_mode (GFX_AUTODETECT, 640, 480, 0, 0) < 0)
		error ("Unable to set video mode", allegro_error);
	set_palette (desktop_palette);	
        clear_to_color(screen, makecol(0, 0, 0));
        
        arena = create_sub_bitmap (screen, 50, 50, 540, 380);
 	score = create_sub_bitmap (screen, 0, 0, 640, 20);	
}

void title_shutdown() 
{
	destroy_bitmap (titlescreen);
}

void init() 
{
 allegro_init();			
 install_timer();		
 install_keyboard();		
 initialise_joystick();
 install_mouse();
}

void shutdown() 
{
 	allegro_exit();
}

void TitleScreen()
{
 if (set_gfx_mode (GFX_AUTODETECT, 800, 600, 0, 0) < 0)
	error ("Unable to set video mode", allegro_error);
 set_palette (desktop_palette);	
 clear_to_color(screen, makecol(0, 0, 0));		
 
 titlescreen = load_bitmap ("title.pcx", palette);
 if (!titlescreen) error ("Unable to load title graphic",NULL); 
 
 set_palette (palette);
 clear_to_color(screen, makecol(0, 0, 0));								
 blit (titlescreen, screen, 0, 0, 0, 0, 800, 600);	
								
 readkey();					
}

